Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -4721,37 +4958,37 @@
 !
 !--             Recompute the south fluxes.
-                ibit14_s = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
-                ibit13_s = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
-                ibit12_s = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
+                ibit5_s = REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )
+                ibit4_s = REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )
+                ibit3_s = REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )
 
                 v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
-                flux_s   = v_comp_s * (                                      &
-                                   ( 37.0_wp * ibit14_s * adv_mom_5             &
-                                +     7.0_wp * ibit13_s * adv_mom_3             &
-                                +              ibit12_s * adv_mom_1             &
-                                   ) *                                       &
-                                     ( u(k,j,i)   + u(k,j-1,i) )             &
-                            -      (  8.0_wp * ibit14_s * adv_mom_5             &
-                            +                  ibit13_s * adv_mom_3             &
-                                   ) *                                       &
-                                     ( u(k,j+1,i) + u(k,j-2,i) )             &
-                        +      (               ibit14_s * adv_mom_5             &
-                               ) *                                           &
-                                     ( u(k,j+2,i) + u(k,j-3,i) )             &
+                flux_s   = v_comp_s * (                                        &
+                                   ( 37.0_wp * ibit5_s * adv_mom_5             &
+                                +     7.0_wp * ibit4_s * adv_mom_3             &
+                                +              ibit3_s * adv_mom_1             &
+                                   ) *                                         &
+                                     ( u(k,j,i)   + u(k,j-1,i) )               &
+                            -      (  8.0_wp * ibit5_s * adv_mom_5             &
+                            +                  ibit4_s * adv_mom_3             &
+                                   ) *                                         &
+                                     ( u(k,j+1,i) + u(k,j-2,i) )               &
+                        +      (               ibit5_s * adv_mom_5             &
+                               ) *                                             &
+                                     ( u(k,j+2,i) + u(k,j-3,i) )               &
                                                )
 
-                diss_s   = - ABS ( v_comp_s ) * (                            &
-                                   ( 10.0_wp * ibit14_s * adv_mom_5              &
-                                +     3.0_wp * ibit13_s * adv_mom_3              &
-                                +              ibit12_s * adv_mom_1              &
-                                   ) *                                        &
-                                     ( u(k,j,i)   - u(k,j-1,i) )              &
-                            -      (  5.0_wp * ibit14_s * adv_mom_5              &
-                                +              ibit13_s * adv_mom_3              &
-                                   ) *                                        &
-                                     ( u(k,j+1,i) - u(k,j-2,i) )              &
-                            +      (           ibit14_s * adv_mom_5              &
-                                   ) *                                        &
-                                     ( u(k,j+2,i) - u(k,j-3,i) )              &
+                diss_s   = - ABS ( v_comp_s ) * (                              &
+                                   ( 10.0_wp * ibit5_s * adv_mom_5             &
+                                +     3.0_wp * ibit4_s * adv_mom_3             &
+                                +              ibit3_s * adv_mom_1             &
+                                   ) *                                         &
+                                     ( u(k,j,i)   - u(k,j-1,i) )               &
+                            -      (  5.0_wp * ibit5_s * adv_mom_5             &
+                                +              ibit4_s * adv_mom_3             &
+                                   ) *                                         &
+                                     ( u(k,j+1,i) - u(k,j-2,i) )               &
+                            +      (           ibit5_s * adv_mom_5             &
+                                   ) *                                         &
+                                     ( u(k,j+2,i) - u(k,j-3,i) )               &
                                                          )
 #else
@@ -4763,41 +5000,41 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-                ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-                ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
-
-                k_ppp = k + 3 * ibit17
-                k_pp  = k + 2 * ( 1 - ibit15  )
-                k_mm  = k - 2 * ibit17
+                ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
+
+                k_ppp = k + 3 * ibit8
+                k_pp  = k + 2 * ( 1 - ibit6  )
+                k_mm  = k - 2 * ibit8
 
                 w_comp = w(k,j,i) + w(k,j,i-1)
-                flux_t = w_comp * rho_air_zw(k) * (                          &
-                          ( 37.0_wp * ibit17 * adv_mom_5                     &
-                       +     7.0_wp * ibit16 * adv_mom_3                     &
-                       +              ibit15 * adv_mom_1                     & 
-                          ) *                                                &
-                             ( u(k+1,j,i)  + u(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit17 * adv_mom_5                     &
-                       +              ibit16 * adv_mom_3                     &
-                          ) *                                                &
-                             ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-                   +      (           ibit17 * adv_mom_5                     &
-                          ) *                                                &
-                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
-                                      )
-
-                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
-                          ( 10.0_wp * ibit17 * adv_mom_5                     &
-                       +     3.0_wp * ibit16 * adv_mom_3                     &
-                       +              ibit15 * adv_mom_1                     &
-                          ) *                                                &
-                             ( u(k+1,j,i)   - u(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit17 * adv_mom_5                     &
-                       +              ibit16 * adv_mom_3                     &
-                          ) *                                                &
-                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-                   +      (           ibit17 * adv_mom_5                     &
-                           ) *                                               &
-                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
+                flux_t = w_comp * rho_air_zw(k) * (                            &
+                          ( 37.0_wp * ibit8 * adv_mom_5                        &
+                       +     7.0_wp * ibit7 * adv_mom_3                        &
+                       +              ibit6 * adv_mom_1                        & 
+                          ) *                                                  &
+                             ( u(k+1,j,i)  + u(k,j,i)     )                    &
+                   -      (  8.0_wp * ibit8 * adv_mom_5                        &
+                       +              ibit7 * adv_mom_3                        &
+                          ) *                                                  &
+                             ( u(k_pp,j,i) + u(k-1,j,i)   )                    &
+                   +      (           ibit8 * adv_mom_5                        &
+                          ) *                                                  &
+                             ( u(k_ppp,j,i) + u(k_mm,j,i) )                    &
+                                      )                                       
+                                                                              
+                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                   &
+                          ( 10.0_wp * ibit8 * adv_mom_5                        &
+                       +     3.0_wp * ibit7 * adv_mom_3                        &
+                       +              ibit6 * adv_mom_1                        &
+                          ) *                                                  &
+                             ( u(k+1,j,i)   - u(k,j,i)    )                    &
+                   -      (  5.0_wp * ibit8 * adv_mom_5                        &
+                       +              ibit7 * adv_mom_3                        &
+                          ) *                                                  &
+                             ( u(k_pp,j,i)  - u(k-1,j,i)  )                    &
+                   +      (           ibit8 * adv_mom_5                        &
+                           ) *                                                 &
+                             ( u(k_ppp,j,i) - u(k_mm,j,i) )                    &
                                               )
 !
@@ -4805,28 +5042,28 @@
 !--             correction is needed to overcome numerical instabilities caused
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp * ( ibit9 + ibit10 + ibit11 )                &
-                - ( u(k,j,i)   + u(k,j,i-1)   )                               &
-                                    * (                                       &
-                    REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )      &
-                  + REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )      &
-                  + REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )      &
-                                      )                                       &
-                  ) * ddx                                                     &
-               +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
-                  - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddy                                                     &
-               +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
-                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_1(k-1,j,i),15,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k-1,j,i),16,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_1(k-1,j,i),17,1), KIND = wp )     &
-                                      )                                       &  
-                  ) * drho_air(k) * ddzw(k)                                   &
+                div = ( ( u_comp * ( ibit0 + ibit1 + ibit2 )                   &
+                - ( u(k,j,i)   + u(k,j,i-1)   )                                &
+                                    * (                                        &
+                    REAL( IBITS(advc_flags_m(k,j,i-1),0,1),  KIND = wp )       &
+                  + REAL( IBITS(advc_flags_m(k,j,i-1),1,1), KIND = wp )        &
+                  + REAL( IBITS(advc_flags_m(k,j,i-1),2,1), KIND = wp )        &
+                                      )                                        &
+                  ) * ddx                                                      &
+               +  ( ( v_comp + gv ) * ( ibit3 + ibit4 + ibit5 )                &
+                  - ( v(k,j,i)   + v(k,j,i-1 )  )                              &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k,j-1,i),3,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),4,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k,j-1,i),5,1), KIND = wp )       &
+                                      )                                        &
+                  ) * ddy                                                      &
+               +  ( w_comp * rho_air_zw(k) * ( ibit6 + ibit7 + ibit8 )         &
+                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)              &
+                                    * (                                        &
+                     REAL( IBITS(advc_flags_m(k-1,j,i),6,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),7,1), KIND = wp )       &
+                   + REAL( IBITS(advc_flags_m(k-1,j,i),8,1), KIND = wp )       &
+                                      )                                        &  
+                  ) * drho_air(k) * ddzw(k)                                    &
                 ) * 0.5_wp
 
@@ -4879,11 +5116,11 @@
 
                 u_comp = u(k,j,i+1) + u(k,j,i)
-                flux_r = ( u_comp - gu ) * (                                  &
-                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                   &
-                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                   &
+                flux_r = ( u_comp - gu ) * (                                   &
+                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                 &
+                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                 &
                        +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
-                diss_r = - ABS( u_comp - gu ) * (                             &
-                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                   &
-                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                   &
+                diss_r = - ABS( u_comp - gu ) * (                              &
+                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                 &
+                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                 &
                        +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
 
@@ -4892,11 +5129,11 @@
 !--             Recompute the left fluxes.
                 u_comp_l = u(k,j,i) + u(k,j,i-1) - gu
-                flux_l   = u_comp_l * (                                       &
-                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )                &
-                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )                &
+                flux_l   = u_comp_l * (                                        &
+                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
+                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
-                diss_l   = - ABS(u_comp_l) * (                                &
-                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )                &
-                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )                &
+                diss_l   = - ABS(u_comp_l) * (                                 &
+                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
+                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
 #else
@@ -4906,11 +5143,11 @@
 
                 v_comp = v(k,j+1,i) + v(k,j+1,i-1) - gv
-                flux_n = v_comp * (                                           &
-                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                   &
-                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                   &
+                flux_n = v_comp * (                                            &
+                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                 &
+                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                 &
                        +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
-                diss_n = - ABS( v_comp ) * (                                  &
-                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                   &
-                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                   &
+                diss_n = - ABS( v_comp ) * (                                   &
+                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                 &
+                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                 &
                        +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
 
@@ -4919,11 +5156,11 @@
 !--             Recompute the south fluxes.
                 v_comp_s = v(k,j,i) + v(k,j,i-1) - gv
-                flux_s   = v_comp_s * (                                       &
-                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )                 &
-                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )                 &
+                flux_s   = v_comp_s * (                                        &
+                           37.0_wp * ( u(k,j,i) + u(k,j-1,i)   )               &
+                         -  8.0_wp * ( u(k,j+1,i) + u(k,j-2,i) )               &
                          +           ( u(k,j+2,i) + u(k,j-3,i) ) ) * adv_mom_5
-                diss_s   = - ABS( v_comp_s ) * (                              &
-                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )                 &
-                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )                 &
+                diss_s   = - ABS( v_comp_s ) * (                               &
+                           10.0_wp * ( u(k,j,i) - u(k,j-1,i)   )               &
+                         -  5.0_wp * ( u(k,j+1,i) - u(k,j-2,i) )               &
                          +           ( u(k,j+2,i) - u(k,j-3,i) ) ) * adv_mom_5
 #else
@@ -4935,24 +5172,24 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
-                ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
-                ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
-
-                k_ppp = k + 3 * ibit17
-                k_pp  = k + 2 * ( 1 - ibit15  )
-                k_mm  = k - 2 * ibit17
+                ibit8 = REAL( IBITS(advc_flags_m(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_m(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_m(k,j,i),6,1), KIND = wp )
+
+                k_ppp = k + 3 * ibit8
+                k_pp  = k + 2 * ( 1 - ibit6  )
+                k_mm  = k - 2 * ibit8
 
                 w_comp = w(k,j,i) + w(k,j,i-1)
                 flux_t = w_comp * rho_air_zw(k) * (                          &
-                          ( 37.0_wp * ibit17 * adv_mom_5                        &
-                       +     7.0_wp * ibit16 * adv_mom_3                        &
-                       +              ibit15 * adv_mom_1                        &
+                          ( 37.0_wp * ibit8 * adv_mom_5                        &
+                       +     7.0_wp * ibit7 * adv_mom_3                        &
+                       +              ibit6 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k+1,j,i)  + u(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit17 * adv_mom_5                        &
-                       +              ibit16 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit8 * adv_mom_5                        &
+                       +              ibit7 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k_pp,j,i) + u(k-1,j,i)   )                  &
-                   +      (           ibit17 * adv_mom_5                        &
+                   +      (           ibit8 * adv_mom_5                        &
                           ) *                                                &
                              ( u(k_ppp,j,i) + u(k_mm,j,i) )                  &
@@ -4960,14 +5197,14 @@
 
                 diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
-                          ( 10.0_wp * ibit17 * adv_mom_5                        &
-                       +     3.0_wp * ibit16 * adv_mom_3                        &
-                       +              ibit15 * adv_mom_1                        &
+                          ( 10.0_wp * ibit8 * adv_mom_5                        &
+                       +     3.0_wp * ibit7 * adv_mom_3                        &
+                       +              ibit6 * adv_mom_1                        &
                           ) *                                                &
                              ( u(k+1,j,i)   - u(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit17 * adv_mom_5                        &
-                       +              ibit16 * adv_mom_3                        &
+                   -      (  5.0_wp * ibit8 * adv_mom_5                        &
+                       +              ibit7 * adv_mom_3                        &
                           ) *                                                &
                              ( u(k_pp,j,i)  - u(k-1,j,i)  )                  &
-                   +      (           ibit17 * adv_mom_5                        &
+                   +      (           ibit8 * adv_mom_5                        &
                            ) *                                               &
                              ( u(k_ppp,j,i) - u(k_mm,j,i) )                  &
@@ -5048,23 +5285,23 @@
        INTEGER(iwp) ::  tn = 0    !< number of OpenMP thread
        
-       REAL(wp)    ::  ibit18 !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit19 !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit20 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit9 !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit11 !< flag indicating 5th-order scheme along x-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit18_l !< flag indicating 1st-order scheme along x-direction
-       REAL(wp)    ::  ibit19_l !< flag indicating 3rd-order scheme along x-direction
-       REAL(wp)    ::  ibit20_l !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit9_l !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit10_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit11_l !< flag indicating 5th-order scheme along x-direction
 #endif
-       REAL(wp)    ::  ibit21 !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit22 !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit23 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit12 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit14 !< flag indicating 5th-order scheme along y-direction
 #ifdef _OPENACC
-       REAL(wp)    ::  ibit21_s !< flag indicating 1st-order scheme along y-direction
-       REAL(wp)    ::  ibit22_s !< flag indicating 3rd-order scheme along y-direction
-       REAL(wp)    ::  ibit23_s !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit12_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit13_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit14_s !< flag indicating 5th-order scheme along y-direction
 #endif
-       REAL(wp)    ::  ibit24 !< flag indicating 1st-order scheme along z-direction
-       REAL(wp)    ::  ibit25 !< flag indicating 3rd-order scheme along z-direction
-       REAL(wp)    ::  ibit26 !< flag indicating 5th-order scheme along z-direction
+       REAL(wp)    ::  ibit15 !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit17 !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< diverence on v-grid
@@ -5127,20 +5364,20 @@
           DO  k = nzb+1, nzb_max_l
 
-             ibit20 = REAL( IBITS(advc_flags_1(k,j,i-1),20,1), KIND = wp )
-             ibit19 = REAL( IBITS(advc_flags_1(k,j,i-1),19,1), KIND = wp )
-             ibit18 = REAL( IBITS(advc_flags_1(k,j,i-1),18,1), KIND = wp )
+             ibit11 = REAL( IBITS(advc_flags_m(k,j,i-1),11,1), KIND = wp )
+             ibit10 = REAL( IBITS(advc_flags_m(k,j,i-1),10,1), KIND = wp )
+             ibit9  = REAL( IBITS(advc_flags_m(k,j,i-1),9,1),  KIND = wp )
 
              u_comp                   = u(k,j-1,i) + u(k,j,i) - gu
              swap_flux_x_local_v(k,j) = u_comp * (                             &
-                                      ( 37.0_wp * ibit20 * adv_mom_5              &
-                                   +     7.0_wp * ibit19 * adv_mom_3              &
-                                   +              ibit18 * adv_mom_1              &
+                                      ( 37.0_wp * ibit11 * adv_mom_5              &
+                                   +     7.0_wp * ibit10 * adv_mom_3              &
+                                   +              ibit9 * adv_mom_1              &
                                       ) *                                      &
                                      ( v(k,j,i)   + v(k,j,i-1) )               &
-                               -      (  8.0_wp * ibit20 * adv_mom_5              &
-                                   +              ibit19 * adv_mom_3              &
+                               -      (  8.0_wp * ibit11 * adv_mom_5              &
+                                   +              ibit10 * adv_mom_3              &
                                       ) *                                      &
                                      ( v(k,j,i+1) + v(k,j,i-2) )               &
-                               +      (           ibit20 * adv_mom_5              &
+                               +      (           ibit11 * adv_mom_5              &
                                       ) *                                      &
                                      ( v(k,j,i+2) + v(k,j,i-3) )               &
@@ -5148,14 +5385,14 @@
 
               swap_diss_x_local_v(k,j) = - ABS( u_comp ) * (                   &
-                                      ( 10.0_wp * ibit20 * adv_mom_5              &
-                                   +     3.0_wp * ibit19 * adv_mom_3              &
-                                   +              ibit18 * adv_mom_1              &
+                                      ( 10.0_wp * ibit11 * adv_mom_5              &
+                                   +     3.0_wp * ibit10 * adv_mom_3              &
+                                   +              ibit9 * adv_mom_1              &
                                       ) *                                      &
                                      ( v(k,j,i)   - v(k,j,i-1) )               &
-                               -      (  5.0_wp * ibit20 * adv_mom_5              &
-                                   +              ibit19 * adv_mom_3              &
+                               -      (  5.0_wp * ibit11 * adv_mom_5              &
+                                   +              ibit10 * adv_mom_3              &
                                       ) *                                      &
                                      ( v(k,j,i+1) - v(k,j,i-2) )               &
-                               +      (           ibit20 * adv_mom_5              &
+                               +      (           ibit11 * adv_mom_5              &
                                       ) *                                      &
                                      ( v(k,j,i+2) - v(k,j,i-3) )               &
@@ -5183,13 +5420,13 @@
        !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
        !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
-       !$ACC PRIVATE(ibit18, ibit19, ibit20, ibit21, ibit22, ibit23) &
-       !$ACC PRIVATE(ibit18_l, ibit19_l, ibit20_l) &
-       !$ACC PRIVATE(ibit21_s, ibit22_s, ibit23_s) &
-       !$ACC PRIVATE(ibit24, ibit25, ibit26) &
+       !$ACC PRIVATE(ibit9, ibit10, ibit11, ibit12, ibit13, ibit14) &
+       !$ACC PRIVATE(ibit9_l, ibit10_l, ibit11_l) &
+       !$ACC PRIVATE(ibit12_s, ibit13_s, ibit14_s) &
+       !$ACC PRIVATE(ibit15, ibit16, ibit17) &
        !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
        !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
        !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
        !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
-       !$ACC PRESENT(advc_flags_1) &
+       !$ACC PRESENT(advc_flags_m) &
        !$ACC PRESENT(u, v, w) &
        !$ACC PRESENT(drho_air, rho_air_zw, ddzw) &
